; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)			
;																				
TIMER_AKTIVIEREN:
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER0 (8Bit) Vorteiler														
;																				
; CS02 CS01 CS00 	Description													
;	0 	0 	0 		No clock source (Timer/Counter stopped).					
;	0 	0 	1 		clkI/O/		(No prescaling)									
;	0 	1 	0 		clkI/O/8 	(From prescaler)								
; *	0 	1 	1 		clkI/O/64 	(From prescaler)								
; 	1 	0 	0 		clkI/O/256 	(From prescaler)								
; 	1 	0 	1 		clkI/O/1024 (From prescaler)								
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.		
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.		
TIMER0_INITIALISIERUNG_ms:
.equ TIMERWERT0	=256-50		; 50;(2 hoch 8  minus...)	
	ldi temp,(0<<CS02)|(1<<CS01)|(1<<CS00)
	OUT TCCR0,temp

	ldi temp, TIMERWERT0	; TIMER0 Startwert		
	mov TIMER0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM0_OVF:
	mov KOPIE_TEMP, TEMP; Sichern von TEMP						
	in	KOPIE_SREG,SREG ; Sichern des SREG 						
;-------------------------------------------------------------------------------
	out TCNT0,TIMER0
	inc COUNTER			; +1				
;-------------------------------------------------------------------------------
; PIN abfragen																	
	LDS temp,(adr_TASTE)
	tst temp			; Taste schon bettigt ?
	brne TIM0_START		; ja-Sprung			
	in temp,PINB		; PIN abfragen		
	com temp
	andi temp,0b11000000
;-------------------------------------------------------------------------------
; RESET ?																		
	cpi temp,0b11000000
	breq TIM0_RESET
;-------------------------------------------------------------------------------
	tst temp
	breq TIM0_START
	BEEP_ON
	STS(adr_TASTE),temp
	rjmp TIM0_START
;-------------------------------------------------------------------------------
TIM0_RESET:
	DIGIT_OFF
	BEEP_ON
	rjmp TIM0_RESET
;-------------------------------------------------------------------------------
TIM0_START:
	DIGIT_OFF
	mov temp,COUNTER
	cpi temp,0
	breq TIM0_D0
	cpi temp,1
	breq TIM0_D1
	rjmp TIM0_D2
;-------------------------------------------------------------------------------
TIM0_D0:
	D0_ON
	LDS temp,(adr_DIGIT0)
	out PORTD,temp
	rjmp TIM0_FERTIG
;-------------------------------------------------------------------------------
TIM0_D1:
	D1_ON
	LDS temp,(adr_DIGIT1)
	out PORTD,temp
	rjmp TIM0_FERTIG
;-------------------------------------------------------------------------------
TIM0_D2:
	D2_ON
	LDS temp,(adr_DIGIT2)
	out PORTD,temp
	mov COUNTER,VOLL 	;-1
;-------------------------------------------------------------------------------
TIM0_FERTIG:
	out	SREG,KOPIE_SREG	; Wiederherstellen von SREG				
	mov TEMP, KOPIE_TEMP; Wiederherstellen von TEMP				
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################


